#ifndef __MAKET_SERVER_H__
#define __MAKET_SERVER_H__

#include "../util/config.h"
#include "TCP.h"
#include <functional>
class EthernetMaketClient;
class EthernetMaketServer : public EthernetServer
{
private:
    // EthernetClient available();
    // void accept(int sock);
    std::function<void(EthernetMaketClient&)> serverHandler = [](EthernetMaketClient &sclient) {};
    SOCKET serverSocket = MAX_SOCK_NUM;

    bool wasConnected;
    EthernetMaketClient sclient;

public:
    using EthernetServer::EthernetServer;
    // EthernetMaketClient available(int sock);

    void setServerHandler(std::function<void(EthernetMaketClient)> handler);
    void resetServerHandler();
    // void begin() override;
    // void begin(int sock);
    void tick();
};

#endif // __MAKET_SERVER_H__
